<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Branch and Jump Instructions</TITLE>
<link href="suif1_34.html" rel=Next>
<link href="suif1_32.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_32.html">previous</A>, <A HREF="suif1_34.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC33" HREF="suif1_toc.html#TOC33">Branch and Jump Instructions</A></H2>
<P>
<A NAME="IDX197"></A>
<A NAME="IDX198"></A>

</P>
<P>
<A NAME="IDX199"></A>
<A NAME="IDX200"></A>
<A NAME="IDX201"></A>
<A NAME="IDX202"></A>
<A NAME="IDX203"></A>
The <CODE>in_bj</CODE> class is used to hold branch and jump instructions.
This class includes a field to specify the label symbol at the branch
target and an optional source operand that is used for conditional
branches.  The <CODE>target</CODE> and <CODE>set_target</CODE> methods are used to
access the label symbol for the branch target.  This label must be
defined in the scope where the branch occurs, and it must be within the
same procedure.  The <CODE>src_op</CODE> and <CODE>set_src_op</CODE> methods access
the optional source operand field.  The <CODE>dst</CODE> operand is unused for
all branch and jump instructions and the result type should always be
the SUIF <CODE>void</CODE> type.  The branch and jump opcodes are described
below:

</P>
<DL COMPACT>

<DT><CODE>jmp</CODE>
<DD>
Unconditional jump.  The source operand is unused.  The flow of control
is unconditionally transferred to the code at the target label.

<DT><CODE>btrue</CODE>
<DD>
Branch if true.  If the source operand, which must have an signed
integer type, contains a true (non-zero) value, the flow of control is
transferred to the code at the target label.  Otherwise, it continues
with the next instruction in sequential order.

<DT><CODE>bfalse</CODE>
<DD>
Branch if false.  If the source operand contains a false (zero) value,
the flow of control is transferred to the code at the target label.
Otherwise, it continues with the next instruction in sequential order.
The source operand must have an signed integer type.
</DL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_32.html">previous</A>, <A HREF="suif1_34.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
